<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>DocStrap Index</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">DocStrap</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="DbPool.html">DbPool</a></li><li><a href="QueryBuilder.html">QueryBuilder</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-8">
	
		<div id="main">
			

	
	











	
	





    <section class="readme-section">
        <article><h1>Querry Builder v 1.2.1</h1><hr>
<h2>INFO</h2><hr>
<blockquote>
<p>This tool is a query builder for <strong>nodeJs</strong> and <strong>pg-pool</strong> (postgre).<br>This also allows to make a pool to connect the database.</p>
</blockquote>
<h2>REQUIREMENTS AND DEPENDENCIES</h2><hr>
<blockquote>
<p>This module needs <strong>nodeJs 8.x</strong> available at: <a href="https://nodejs.org/en/">https://nodejs.org</a></p>
<p>And it requires these two modules: </p>
<ul>
<li>pg       [ <a href="https://www.npmjs.com/package/pg">npm pg</a> ]</li>
<li>pg-pool  [ <a href="https://www.npmjs.com/package/pg-pool">npm pg-pool</a> ]</li>
</ul>
<p>Those two modules are made sire Brianc, you can visit all of his work at <i><bold><a href="https://www.npmjs.com/~brianc">npm-brianc</a></bold></i></p>
</blockquote>
<p>make sure to launch  <code>$ npm install</code>.<br>If it does not work use <code>$ npm install pg-pool pg --save</code>.</p>
<h2>FEATURES</h2><hr>
<blockquote>
<p>The module allows to make queries:</p>
<ul>
<li>SELECT</li>
<li>INSERT</li>
<li>UPDATE</li>
<li>DELETE</li>
<li>subQuery &quot;EXISTS&quot;, &quot;IN&quot;, &quot;NOT IN&quot;</li>
<li>GROUP BY</li>
<li>HAVING</li>
</ul>
<p>The module include the:</p>
<ul>
<li>idleTimeoutMillis</li>
<li>connectionTimeoutMillis</li>
</ul>
<p>using the existing pg-pool object</p>
</blockquote>
<h3>GET STARTED</h3><hr>
<blockquote>
<p>To make it simple I use express and body-parser to write my APIs but the usage is the same.<br>You can launch </p>
<pre class="prettyprint source lang-bash"><code>$ npm install express body-parser</code></pre><p>Or you can add these two more dependencies to add in your package.json:</p>
<pre class="prettyprint source lang-json"><code>&quot;dependencies&quot;: {
   &quot;body-parser&quot;: &quot;^1.18.2&quot;,
   &quot;express&quot;: &quot;^4.16.0&quot;
}</code></pre><p>and run</p>
<pre class="prettyprint source lang-bash"><code>$ npm install</code></pre></blockquote>
<p>Here there are a few example of usage, do not hesitate to read full <a href="#DOCUMENTATION">documentation</a></p>
<pre class="prettyprint source lang-javascript"><code>// simple express app launching ...
const express = require('express');
let app = express();

// import the QueryBuilder class
const QueryBuilder = require('pg-pool-query-builder');

// Make a pool 
let pool = new QueryBuilder({
    dbName:process.env.dbName,
    dbUser: process.env.dbUser,
    dbHost: process.env.dbHost,
    dbPort: process.env.dbPort,
    dbPassword: process.env.dbPassword
});

// GET synchronously person API
app.get('/person/sync', async (req, res)=>{

    let data = await
        pool.select(&quot;*&quot;)
            .from(&quot;person&quot;)
            .where(&quot;firstname&quot;)
            .in(&quot;toto&quot;)
            .syncExecute();

    res.status(200).json(data.rows);
});

// GET person API
app.get('/person', (req, res)=>{

    pool.select(&quot;*&quot;)
        .from(&quot;person&quot;)
        .where({
            &quot;firstname&quot;: 'toto',
            &quot;age&quot;: [25, 26]
        })
        .execute()
        .then( data => res.status(200).json(data.rows) )
        .catch( err => res.status(500).send(`ouch! error: ${err}`));
});

//GET person with subQuery
app.get('/personSubQuery', (req, res)=>{

    pool.select(&quot;*&quot;)
        .from(&quot;person&quot;)
        .where(&quot;firstname&quot;)
        .startSubQuery(&quot;IN&quot;)
            .select(&quot;firstname&quot;)
            .from(&quot;person&quot;)
        .endSubQuery()
        .execute()
        .then( data => res.status(200).json(data.rows) )
        .catch( err => res.status(500).send(`ouch! error: ${err}`));
});

//GET COUNT(id) person
app.get('/personCountId', (req, res)=>{

    pool.maxConnectionTimeout(0.1)
        .select([&quot;firstname&quot;, &quot;lastname&quot;, &quot;COUNT (id) &quot;])
        .from(&quot;person&quot;)
        .groupBy([&quot;firstname&quot;, &quot;lastname&quot;])
        .having(&quot; COUNT(id) &lt;= 10&quot;)
        .execute()
        .then( data => res.status(200).json(data.rows) )
        .catch( err => res.status(500).send(`ouch! error: ${err}`));
});

// POST person API
app.post('/person', async (req, res)=>{
    let person = req.body.person;
    let columns = Object.keys(person);
    let values = Object.values(person);

    let data = await
        pool.insert(&quot;person&quot;, columns)
            .values(values)
            .syncExecute();

    res.status(200).json(data);
});

// PUT person API
app.put('/person', async (req, res)=>{
    let person = req.body.person;
    let id = person.id;
    delete person.id;

    let data =
        pool.update(&quot;person&quot;)
            .set(person)
            .where(&quot;id&quot;)
            .equal(id)
            .syncExecute()
            .catch( err => res.status(500).json(err) );

    res.status(200).json(data);
});

// DELETE person API
app.delete('/person', async (req, res)=>{
    let person = req.body.person;

    let data =
        pool.delete()
            .from(&quot;person&quot;)
            .where(&quot;id&quot;)
            .equal(person.id)
            .syncExecute()
            .catch( err => res.status(500).json(err) );

    res.status(200).json(data);
});

// start listening
app.listen(process.env.port);</code></pre><h2><a name="DOCUMENTATION"></a>DOCUMENTATION</h2><hr>
<p>All the documentations available at <code>&lt;yourDirectory&gt;\node_modules\pg-pool-query-builder\doc\index.html</code>  </p>
<blockquote>
<p>I will serve the doc by myself in a few moment ...<br>I will soon receive my raspberry to serve it myself </p>
</blockquote>
<h2>BY THE WAY</h2><hr>
<p>Special thanks to <a href="https://www.npmjs.com/~brianc">brianc</a>.  </p>
<p>I'll make a greater &quot;get started&quot; when I serve documentation By myself.  </p>
<p>An EcmaScript 5 exist in the folder, I did not test it, i just made it with babel without caring of it by now.<br>If it is asked I'll make a npm module for its ES5 version.</p>
<p>I think you can add issues at <i><bold><a href="https://gitlab.com/colloc_blagnac/querybuilder/issues">gitIssues</a></bold></i></p>
<h2>LICENSE</h2><hr>
<p>ISC</p></article>
    </section>







		</div>
	</div>

	<div class="clearfix"></div>

	
		<div class="col-md-3">
			<div id="toc" class="col-md-3 hidden-xs hidden-sm hidden-md"></div>
		</div>
	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>


	<span class="copyright">
	DocStrap Copyright © 2012-2015 The contributors to the JSDoc3 and DocStrap projects.
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a>
	
		on Sun Oct 15th 2017
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>